/*-
 * Copyright (c) 2017-2021, AT&T Intellectual Property.  All rights reserved.
 * Copyright (c) 2013-2016 by Brocade Communications Systems, Inc.
 * All rights reserved.
 *
 * SPDX-License-Identifier: LGPL-2.1-only
 */

#ifndef VPLANE_LOG_H
#define VPLANE_LOG_H

#include <rte_log.h>
#include "debug.h"

/* USER1 - infrastructure */
#define RTE_LOGTYPE_SHADOW	RTE_LOGTYPE_USER1
#define RTE_LOGTYPE_DIST	RTE_LOGTYPE_USER1
#define RTE_LOGTYPE_FAL		RTE_LOGTYPE_USER1
#define RTE_LOGTYPE_BACKPLANE   RTE_LOGTYPE_USER1

/* USER2 - layered devices */
#define RTE_LOGTYPE_BRIDGE	RTE_LOGTYPE_USER2
#define RTE_LOGTYPE_MACVLAN	RTE_LOGTYPE_USER2
#define RTE_LOGTYPE_VXLAN	RTE_LOGTYPE_USER2
#define RTE_LOGTYPE_L2TP	RTE_LOGTYPE_USER2
#define RTE_LOGTYPE_GRE		RTE_LOGTYPE_USER2
#define RTE_LOGTYPE_NSH		RTE_LOGTYPE_USER2

/* USER3 - routing, arp etc */
#define RTE_LOGTYPE_ROUTE	RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_ROUTE6	RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_MCAST	RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_ARP		RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_ND6		RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_LLADDR	RTE_LOGTYPE_USER3
#define RTE_LOGTYPE_MPLS	RTE_LOGTYPE_USER3

/* USER4 - features */
#define RTE_LOGTYPE_FIREWALL	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_QOS		RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_QOS_DP	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_QOS_HW	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_PPPOE	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_APP		RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_NAT64	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_NAT46	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_STORM_CTL   RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_CPP_RL	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_CGNAT	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_ACL_HW	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_MAC_LIMIT	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_GPC		RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_TWAMP	RTE_LOGTYPE_USER4
#define RTE_LOGTYPE_SFP_PL	RTE_LOGTYPE_USER4

/* USER5 - crypto */
#define RTE_LOGTYPE_VTI		RTE_LOGTYPE_USER5
#define RTE_LOGTYPE_ESP		RTE_LOGTYPE_USER5
#define RTE_LOGTYPE_CRYPTO	RTE_LOGTYPE_USER5
#define RTE_LOGTYPE_SADB	RTE_LOGTYPE_USER5
#define RTE_LOGTYPE_POLICY	RTE_LOGTYPE_USER5
#define RTE_LOGTYPE_ENGINE	RTE_LOGTYPE_USER5

#endif /* VPLANE_LOG_H */
